diff --git a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
index 2b2969cd3..a74e34b68 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
@@ -133,364 +172,187 @@ public class StaticEntityModelMojang implements StaticEntityModel {
             final double maxY = minY + cube.size[1] + (cube.inflate + bone.inflate + this.inflation) * 2;
             final double maxZ = minZ + cube.size[2] + (cube.inflate + bone.inflate + this.inflation) * 2;
 
-            if (cube.rotation == null) {
-                // Top
-                Face face = cube.faces[Direction.UP.getId()];
-                if (face != null) {
-                    final double uMin = (face.uv[0]) / this.data.textureWidth;
-                    final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
-                    final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
-
-                    this.uvsBuffer[0] = uMin;
-                    this.uvsBuffer[2] = uMin;
-                    this.uvsBuffer[4] = uMax;
-                    this.uvsBuffer[6] = uMax;
-
-                    this.uvsBuffer[1] = vMin;
-                    this.uvsBuffer[3] = vMax;
-                    this.uvsBuffer[5] = vMax;
-                    this.uvsBuffer[7] = vMin;
-
-                    tessellator.setNormal(0, 1, 0);
-                    tessellator.addVertexWithUV(minX, maxY, maxZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(minX, maxY, minZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(maxX, maxY, minZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(maxX, maxY, maxZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8]);
-                }
-
-                // Bottom
-                face = cube.faces[Direction.DOWN.getId()];
-                if (face != null) {
-                    final double uMin = (face.uv[0]) / this.data.textureWidth;
-                    final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
-                    final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
-
-                    this.uvsBuffer[0] = uMin;
-                    this.uvsBuffer[2] = uMax;
-                    this.uvsBuffer[4] = uMax;
-                    this.uvsBuffer[6] = uMin;
-
-                    this.uvsBuffer[1] = vMax;
-                    this.uvsBuffer[3] = vMax;
-                    this.uvsBuffer[5] = vMin;
-                    this.uvsBuffer[7] = vMin;
-
-                    tessellator.setNormal(0, -1, 0);
-                    tessellator.addVertexWithUV(minX, minY, maxZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(maxX, minY, maxZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(maxX, minY, minZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(minX, minY, minZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8]);
-                }
-
-                // Front
-                face = cube.faces[Direction.NORTH.getId()];
-                if (face != null) {
-                    final double uMin = (face.uv[0]) / this.data.textureWidth;
-                    final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
-                    final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
-
-                    this.uvsBuffer[0] = uMin;
-                    this.uvsBuffer[2] = uMax;
-                    this.uvsBuffer[4] = uMax;
-                    this.uvsBuffer[6] = uMin;
-
-                    this.uvsBuffer[1] = vMax;
-                    this.uvsBuffer[3] = vMax;
-                    this.uvsBuffer[5] = vMin;
-                    this.uvsBuffer[7] = vMin;
-
-                    tessellator.setNormal(0, 0, -1);
-                    tessellator.addVertexWithUV(minX, minY, minZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(maxX, minY, minZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(maxX, maxY, minZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(minX, maxY, minZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8]);
-                }
+            // Top
+            Face face = cube.faces[Direction.UP.getId()];
+            if (face != null) {
+                final double uMin = (face.uv[0]) / this.data.textureWidth;
+                final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
+                final double vMin = (face.uv[1]) / this.data.textureHeight;
+                final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
+
+                this.uvsBuffer[0] = uMin;
+                this.uvsBuffer[2] = uMin;
+                this.uvsBuffer[4] = uMax;
+                this.uvsBuffer[6] = uMax;
+
+                this.uvsBuffer[1] = vMin;
+                this.uvsBuffer[3] = vMax;
+                this.uvsBuffer[5] = vMax;
+                this.uvsBuffer[7] = vMin;
+
+                tessellator.setNormal(0, 1, 0);
+                addRotatedVertex(tessellator, minX, maxY, maxZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, minX, maxY, minZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, maxX, maxY, minZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, maxX, maxY, maxZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
 
-                // Back
-                face = cube.faces[Direction.SOUTH.getId()];
-                if (face != null) {
-                    final double uMin = (face.uv[0]) / this.data.textureWidth;
-                    final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
-                    final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
-
-                    this.uvsBuffer[0] = uMax;
-                    this.uvsBuffer[2] = uMax;
-                    this.uvsBuffer[4] = uMin;
-                    this.uvsBuffer[6] = uMin;
-
-                    this.uvsBuffer[1] = vMax;
-                    this.uvsBuffer[3] = vMin;
-                    this.uvsBuffer[5] = vMin;
-                    this.uvsBuffer[7] = vMax;
-
-                    tessellator.setNormal(0, 0, 1);
-                    tessellator.addVertexWithUV(minX, minY, maxZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(minX, maxY, maxZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(maxX, maxY, maxZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(maxX, minY, maxZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8]);
-                }
-
-                // Right
-                face = cube.faces[Direction.WEST.getId()];
-                if (face != null) {
-                    final double uMin = (face.uv[0]) / this.data.textureWidth;
-                    final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
-                    final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
-
-                    this.uvsBuffer[0] = uMax;
-                    this.uvsBuffer[2] = uMax;
-                    this.uvsBuffer[4] = uMin;
-                    this.uvsBuffer[6] = uMin;
-
-                    this.uvsBuffer[1] = vMax;
-                    this.uvsBuffer[3] = vMin;
-                    this.uvsBuffer[5] = vMin;
-                    this.uvsBuffer[7] = vMax;
-
-                    tessellator.setNormal(1, 0, 0);
-                    tessellator.addVertexWithUV(maxX, minY, maxZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(maxX, maxY, maxZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(maxX, maxY, minZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(maxX, minY, minZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8]);
-                }
-
-                // Left
-                face = cube.faces[Direction.EAST.getId()];
-                if (face != null) {
-                    final double uMin = (face.uv[0]) / this.data.textureWidth;
-                    final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
-                    final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
-
-                    this.uvsBuffer[0] = uMin;
-                    this.uvsBuffer[2] = uMax;
-                    this.uvsBuffer[4] = uMax;
-                    this.uvsBuffer[6] = uMin;
-
-                    this.uvsBuffer[1] = vMax;
-                    this.uvsBuffer[3] = vMax;
-                    this.uvsBuffer[5] = vMin;
-                    this.uvsBuffer[7] = vMin;
-
-                    tessellator.setNormal(-1, 0, 0);
-                    tessellator.addVertexWithUV(minX, minY, maxZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(minX, minY, minZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(minX, maxY, minZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8]);
-                    tessellator.addVertexWithUV(minX, maxY, maxZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8]);
-                }
-            } else {
-                // Top
-                Face face = cube.faces[Direction.UP.getId()];
-                if (face != null) {
-                    final double uMin = (face.uv[0]) / this.data.textureWidth;
-                    final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
-                    final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
-
-                    this.uvsBuffer[0] = uMin;
-                    this.uvsBuffer[2] = uMin;
-                    this.uvsBuffer[4] = uMax;
-                    this.uvsBuffer[6] = uMax;
-
-                    this.uvsBuffer[1] = vMin;
-                    this.uvsBuffer[3] = vMax;
-                    this.uvsBuffer[5] = vMax;
-                    this.uvsBuffer[7] = vMin;
-
-                    tessellator.setNormal(0, 1, 0);
-                    addRotatedVertex(tessellator, minX, maxY, maxZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, minX, maxY, minZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, maxX, maxY, minZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, maxX, maxY, maxZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-
-                }
+            }
 
-                // Bottom
-                face = cube.faces[Direction.DOWN.getId()];
-                if (face != null) {
-                    final double uMin = (face.uv[0]) / this.data.textureWidth;
-                    final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
-                    final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
-
-                    this.uvsBuffer[0] = uMin;
-                    this.uvsBuffer[2] = uMax;
-                    this.uvsBuffer[4] = uMax;
-                    this.uvsBuffer[6] = uMin;
-
-                    this.uvsBuffer[1] = vMax;
-                    this.uvsBuffer[3] = vMax;
-                    this.uvsBuffer[5] = vMin;
-                    this.uvsBuffer[7] = vMin;
-
-                    tessellator.setNormal(0, -1, 0);
-                    addRotatedVertex(tessellator, minX, minY, maxZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, maxX, minY, maxZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, maxX, minY, minZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, minX, minY, minZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                }
+            // Bottom
+            face = cube.faces[Direction.DOWN.getId()];
+            if (face != null) {
+                final double uMin = (face.uv[0]) / this.data.textureWidth;
+                final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
+                final double vMin = (face.uv[1]) / this.data.textureHeight;
+                final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
+
+                this.uvsBuffer[0] = uMin;
+                this.uvsBuffer[2] = uMax;
+                this.uvsBuffer[4] = uMax;
+                this.uvsBuffer[6] = uMin;
+
+                this.uvsBuffer[1] = vMax;
+                this.uvsBuffer[3] = vMax;
+                this.uvsBuffer[5] = vMin;
+                this.uvsBuffer[7] = vMin;
+
+                tessellator.setNormal(0, -1, 0);
+                addRotatedVertex(tessellator, minX, minY, maxZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, maxX, minY, maxZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, maxX, minY, minZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, minX, minY, minZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+            }
 
-                // Front
-                face = cube.faces[Direction.NORTH.getId()];
-                if (face != null) {
-                    final double uMin = (face.uv[0]) / this.data.textureWidth;
-                    final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
-                    final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
-
-                    this.uvsBuffer[0] = uMin;
-                    this.uvsBuffer[2] = uMax;
-                    this.uvsBuffer[4] = uMax;
-                    this.uvsBuffer[6] = uMin;
-
-                    this.uvsBuffer[1] = vMax;
-                    this.uvsBuffer[3] = vMax;
-                    this.uvsBuffer[5] = vMin;
-                    this.uvsBuffer[7] = vMin;
-
-                    tessellator.setNormal(0, 0, -1);
-                    addRotatedVertex(tessellator, minX, minY, minZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, maxX, minY, minZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, maxX, maxY, minZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, minX, maxY, minZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                }
+            // Front
+            face = cube.faces[Direction.NORTH.getId()];
+            if (face != null) {
+                final double uMin = (face.uv[0]) / this.data.textureWidth;
+                final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
+                final double vMin = (face.uv[1]) / this.data.textureHeight;
+                final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
+
+                this.uvsBuffer[0] = uMin;
+                this.uvsBuffer[2] = uMax;
+                this.uvsBuffer[4] = uMax;
+                this.uvsBuffer[6] = uMin;
+
+                this.uvsBuffer[1] = vMax;
+                this.uvsBuffer[3] = vMax;
+                this.uvsBuffer[5] = vMin;
+                this.uvsBuffer[7] = vMin;
+
+                tessellator.setNormal(0, 0, -1);
+                addRotatedVertex(tessellator, minX, minY, minZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, maxX, minY, minZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, maxX, maxY, minZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, minX, maxY, minZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+            }
 
-                // Back
-                face = cube.faces[Direction.SOUTH.getId()];
-                if (face != null) {
-                    final double uMin = (face.uv[0]) / this.data.textureWidth;
-                    final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
-                    final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
-
-                    this.uvsBuffer[0] = uMax;
-                    this.uvsBuffer[2] = uMax;
-                    this.uvsBuffer[4] = uMin;
-                    this.uvsBuffer[6] = uMin;
-
-                    this.uvsBuffer[1] = vMax;
-                    this.uvsBuffer[3] = vMin;
-                    this.uvsBuffer[5] = vMin;
-                    this.uvsBuffer[7] = vMax;
-
-                    tessellator.setNormal(0, 0, 1);
-                    addRotatedVertex(tessellator, minX, minY, maxZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, minX, maxY, maxZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, maxX, maxY, maxZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, maxX, minY, maxZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                }
+            // Back
+            face = cube.faces[Direction.SOUTH.getId()];
+            if (face != null) {
+                final double uMin = (face.uv[0]) / this.data.textureWidth;
+                final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
+                final double vMin = (face.uv[1]) / this.data.textureHeight;
+                final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
+
+                this.uvsBuffer[0] = uMax;
+                this.uvsBuffer[2] = uMax;
+                this.uvsBuffer[4] = uMin;
+                this.uvsBuffer[6] = uMin;
+
+                this.uvsBuffer[1] = vMax;
+                this.uvsBuffer[3] = vMin;
+                this.uvsBuffer[5] = vMin;
+                this.uvsBuffer[7] = vMax;
+
+                tessellator.setNormal(0, 0, 1);
+                addRotatedVertex(tessellator, minX, minY, maxZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, minX, maxY, maxZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, maxX, maxY, maxZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, maxX, minY, maxZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+            }
 
-                // Right
-                face = cube.faces[Direction.WEST.getId()];
-                if (face != null) {
-                    final double uMin = (face.uv[0]) / this.data.textureWidth;
-                    final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
-                    final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
-
-                    this.uvsBuffer[0] = uMax;
-                    this.uvsBuffer[2] = uMax;
-                    this.uvsBuffer[4] = uMin;
-                    this.uvsBuffer[6] = uMin;
-
-                    this.uvsBuffer[1] = vMax;
-                    this.uvsBuffer[3] = vMin;
-                    this.uvsBuffer[5] = vMin;
-                    this.uvsBuffer[7] = vMax;
-
-                    tessellator.setNormal(1, 0, 0);
-                    addRotatedVertex(tessellator, maxX, minY, maxZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, maxX, maxY, maxZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, maxX, maxY, minZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, maxX, minY, minZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                }
+            // Right
+            face = cube.faces[Direction.WEST.getId()];
+            if (face != null) {
+                final double uMin = (face.uv[0]) / this.data.textureWidth;
+                final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
+                final double vMin = (face.uv[1]) / this.data.textureHeight;
+                final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
+
+                this.uvsBuffer[0] = uMax;
+                this.uvsBuffer[2] = uMax;
+                this.uvsBuffer[4] = uMin;
+                this.uvsBuffer[6] = uMin;
+
+                this.uvsBuffer[1] = vMax;
+                this.uvsBuffer[3] = vMin;
+                this.uvsBuffer[5] = vMin;
+                this.uvsBuffer[7] = vMax;
+
+                tessellator.setNormal(1, 0, 0);
+                addRotatedVertex(tessellator, maxX, minY, maxZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, maxX, maxY, maxZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, maxX, maxY, minZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, maxX, minY, minZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+            }
 
-                // Left
-                face = cube.faces[Direction.EAST.getId()];
-                if (face != null) {
-                    final double uMin = (face.uv[0]) / this.data.textureWidth;
-                    final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
-                    final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
-
-                    this.uvsBuffer[0] = uMin;
-                    this.uvsBuffer[2] = uMax;
-                    this.uvsBuffer[4] = uMax;
-                    this.uvsBuffer[6] = uMin;
-
-                    this.uvsBuffer[1] = vMax;
-                    this.uvsBuffer[3] = vMax;
-                    this.uvsBuffer[5] = vMin;
-                    this.uvsBuffer[7] = vMin;
-
-                    tessellator.setNormal(-1, 0, 0);
-                    addRotatedVertex(tessellator, minX, minY, maxZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, minX, minY, minZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, minX, maxY, minZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                    addRotatedVertex(tessellator, minX, maxY, maxZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
-                }
+            // Left
+            face = cube.faces[Direction.EAST.getId()];
+            if (face != null) {
+                final double uMin = (face.uv[0]) / this.data.textureWidth;
+                final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
+                final double vMin = (face.uv[1]) / this.data.textureHeight;
+                final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
+
+                this.uvsBuffer[0] = uMin;
+                this.uvsBuffer[2] = uMax;
+                this.uvsBuffer[4] = uMax;
+                this.uvsBuffer[6] = uMin;
+
+                this.uvsBuffer[1] = vMax;
+                this.uvsBuffer[3] = vMax;
+                this.uvsBuffer[5] = vMin;
+                this.uvsBuffer[7] = vMin;
+
+                tessellator.setNormal(-1, 0, 0);
+                addRotatedVertex(tessellator, minX, minY, maxZ, this.uvsBuffer[(face.uv_rotation * 2) % 8], this.uvsBuffer[(1 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, minX, minY, minZ, this.uvsBuffer[(2 + face.uv_rotation * 2) % 8], this.uvsBuffer[(3 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, minX, maxY, minZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
+                addRotatedVertex(tessellator, minX, maxY, maxZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8], cube.pivot, cube.rotation);
             }
         }
-        tessellator.draw();
     }
 
-    protected static void addRotatedVertex(@NotNull final TessellatorEntity tessellator, final double x, final double y, final double z, final double u, final double v, final double @NotNull [] pivot, final double @NotNull [] rotation) {
-        double _x = x - pivot[0];
-        double _y = y - pivot[1];
-        double _z = z - pivot[2];
-
-        float sin;
-        float cos;
-        double nx;
-        double ny;
-        double nz;
-
-        // X
-        sin = MathHelper.sin((float) (-rotation[0] * MathHelper.DEG_TO_RAD));
-        cos = MathHelper.cos((float) (-rotation[0] * MathHelper.DEG_TO_RAD));
-        nx = _x;
-        ny = _y * cos - _z * sin;
-        nz = _z * cos + _y * sin;
-        _x = nx;
-        _y = ny;
-        _z = nz;
-
-        // Y
-        sin = MathHelper.sin((float) (-rotation[1] * MathHelper.DEG_TO_RAD));
-        cos = MathHelper.cos((float) (-rotation[1] * MathHelper.DEG_TO_RAD));
-        nx = _x * cos - _z * sin;
-        ny = _y;
-        nz = _z * cos + _x * sin;
-        _x = nx;
-        _y = ny;
-        _z = nz;
-
-        // Z
-        sin = MathHelper.sin((float) (-rotation[2] * MathHelper.DEG_TO_RAD));
-        cos = MathHelper.cos((float) (-rotation[2] * MathHelper.DEG_TO_RAD));
-        nx = _x * cos - _y * sin;
-        ny = _y * cos + _x * sin;
-        nz = _z;
-        _x = nx;
-        _y = ny;
-        _z = nz;
-
-
-        tessellator.addVertexWithUV(_x + pivot[0], _y + pivot[1], _z + pivot[2], u, v);
+    private static final @NotNull Vector3d q = new Vector3d();
+    protected static void addRotatedVertex(@NotNull final TessellatorEntity tessellator, final double x, final double y, final double z, final double u, final double v, final @NotNull Vector3dc pivot, final @Nullable Vector3dc rotation) {
+        if (rotation == null) {
+            tessellator.addVertexWithUV(x, y, z, u, v);
+        } else {
+            q.set(x, y, z)
+                .sub(pivot)
+                .rotateX(-rotation.x() * MathHelper.DEG_TO_RAD)
+                .rotateY(-rotation.y() * MathHelper.DEG_TO_RAD)
+                .rotateZ(-rotation.z() * MathHelper.DEG_TO_RAD)
+                .add(pivot);
+            tessellator.addVertexWithUV(q, u, v);
+        }
+    }
+
+    public record BoneEntry(@NotNull Bone bone, int index) {
+
     }
 
     public static class TessellatorEntity {
         private static final Logger LOGGER = LogUtils.getLogger();
-        private static final int VERT_SIZE = 5 * Float.BYTES + 3;
+        private static final int VERT_SIZE = 5 * Float.BYTES + 7;
         public ByteBuffer data;
 
         public boolean drawing;
 
+        public int boneIndex = 0;
+
         public byte normalX = 0;
         public byte normalY = -128;
         public byte normalZ = 0;
